RWMol.h
Go to the documentation of this file.
//
// Copyright (C) 2003-2009 Greg Landrum and Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
/*! \file RWMol.h
\brief Defines the editable molecule class \c RWMol
*/
#ifndef __RD_RWMOL_H__
#define __RD_RWMOL_H__
// our stuff
#include "ROMol.h"
#include "RingInfo.h"
namespace RDKit {
//! RWMol is a molecule class that is intended to be edited
/*!
See documentation for ROMol for general remarks
*/
class RWMol : public ROMol {
public:
RWMol() { d_partialBonds.clear(); }
//! copy constructor with a twist
/*!
\param other the molecule to be copied
\param quickCopy (optional) if this is true, the resulting ROMol will not
copy any of the properties or bookmarks and conformers from \c other.
This can
make the copy substantially faster (thus the name).
\param confId if this is >=0, the resulting ROMol will contain only
the specified conformer from \c other.
*/
RWMol(const ROMol &other, bool quickCopy = false, int confId = -1) {
d_partialBonds.clear();
initFromOther(other, quickCopy, confId);
};
RWMol &operator=(const RWMol &);
//! insert the atoms and bonds from \c other into this molecule
void insertMol(const ROMol &other);
//! \name Atoms
//@{
//! adds an empty Atom to our collection
/*!
\param updateLabel (optional) if this is true, the new Atom will be
our \c activeAtom
\return the new number of atoms
*/
unsigned int addAtom(bool updateLabel = true);
//! adds an Atom to our collection
/*!
\param atom pointer to the Atom to add
\param updateLabel (optional) if this is true, the new Atom will be
our \c activeAtom
\param takeOwnership (optional) if this is true, we take ownership of \c
atom
instead of copying it.
\return the new number of atoms
*/
unsigned int addAtom(Atom *atom, bool updateLabel = true,
bool takeOwnership = false) {
return ROMol::addAtom(atom, updateLabel, takeOwnership);
};
//! adds an Atom to our collection
/*!
\param atom pointer to the Atom to add
\param updateLabel (optional) if this is true, the new Atom will be
our \c activeAtom
\return the new number of atoms
<b>Note:</b> since this is using a smart pointer, we don't need to worry
about
issues of ownership.
*/
unsigned int addAtom(ATOM_SPTR atom, bool updateLabel = true) {
return ROMol::addAtom(atom, updateLabel);
};
//! replaces a particular Atom
/*!
\param idx the index of the Atom to replace
\param atom the new atom, which will be copied.
\param updateLabel (optional) if this is true, the new Atom will be
our \c activeAtom
*/
void replaceAtom(unsigned int idx, Atom *atom, bool updateLabel = false);
//! returns a pointer to the highest-numbered Atom
Atom *getLastAtom() { return getAtomWithIdx(getNumAtoms() - 1); };
//! returns a pointer to the "active" Atom
/*!
If we have an \c activeAtom, it will be returned,
otherwise the results of getLastAtom() will be returned.
*/
Atom *getActiveAtom();
//! sets our \c activeAtom
void setActiveAtom(Atom *atom);
//! \overload
void setActiveAtom(unsigned int idx);
//! removes an Atom from the molecule
void removeAtom(unsigned int idx);
//! \overload
void removeAtom(Atom *atom);
//@}
//! \name Bonds
//@{
//! adds a Bond between the indicated Atoms
/*!
\return the number of Bonds
*/
unsigned int addBond(unsigned int beginAtomIdx, unsigned int endAtomIdx,
Bond::BondType order = Bond::UNSPECIFIED);
//! \overload
unsigned int addBond(ATOM_SPTR beginAtom, ATOM_SPTR endAtom,
Bond::BondType order = Bond::UNSPECIFIED);
//! \overload
unsigned int addBond(Atom *beginAtom, Atom *endAtom,
Bond::BondType order = Bond::UNSPECIFIED);
//! adds a Bond to our collection
/*!
\param bond pointer to the Bond to add
\param takeOwnership (optional) if this is true, we take ownership of \c
bond
instead of copying it.
\return the new number of bonds
*/
unsigned int addBond(Bond *bond, bool takeOwnership = false) {
return ROMol::addBond(bond, takeOwnership);
};
//! adds a Bond to our collection
/*!
\param bsp smart pointer to the Bond to add
\return the new number of bonds
<b>Note:</b> since this is using a smart pointer, we don't need to worry
about
issues of ownership.
*/
unsigned int addBond(BOND_SPTR bsp) { return ROMol::addBond(bsp); };
//! starts a Bond and sets its beginAtomIdx
/*!
\return a pointer to the new bond
The caller should set a bookmark to the returned Bond in order
to be able to later complete it:
\verbatim
Bond *pBond = mol->createPartialBond(1);
mol->setBondBookmark(pBond,666);
... do some other stuff ...
mol->finishPartialBond(2,666,Bond::SINGLE);
mol->clearBondBookmark(666,pBond);
\endverbatim
or, if we want to set the \c BondType initially:
\verbatim
Bond *pBond = mol->createPartialBond(1,Bond::DOUBLE);
mol->setBondBookmark(pBond,666);
... do some other stuff ...
mol->finishPartialBond(2,666);
mol->clearBondBookmark(666,pBond);
\endverbatim
the call to finishPartialBond() will take priority if you set the
\c BondType in both calls.
*/
Bond *createPartialBond(unsigned int beginAtomIdx,
Bond::BondType order = Bond::UNSPECIFIED);
//! finishes a partially constructed bond
/*!
\return the final number of Bonds
See the documentation for createPartialBond() for more details
*/
unsigned int finishPartialBond(unsigned int endAtomIdx, int bondBookmark,
Bond::BondType order = Bond::UNSPECIFIED);
//! removes a bond from the molecule
void removeBond(unsigned int beginAtomIdx, unsigned int endAtomIdx);
//@}
//! removes all atoms, bonds, properties, bookmarks, etc.
void clear() {
d_atomBookmarks.clear();
d_bondBookmarks.clear();
d_graph.clear();
d_confs.clear();
if (dp_props) {
dp_props->reset();
STR_VECT computed;
dp_props->setVal(detail::computedPropName, computed);
}
if (dp_ringInfo) dp_ringInfo->reset();
};
private:
std::vector<BOND_SPTR> d_partialBonds;
void destroy();
};
typedef boost::shared_ptr<RWMol> RWMOL_SPTR;
typedef std::vector<RWMOL_SPTR> RWMOL_SPTR_VECT;
}; // end of RDKit namespace
#endif
RDKit::BOND_SPTR
boost::shared_ptr< Bond > BOND_SPTR
Definition: ROMol.h:41
RDKit::RWMol::clear
void clear()
removes all atoms, bonds, properties, bookmarks, etc.
Definition: RWMol.h:212
RDKit::RWMOL_SPTR_VECT
std::vector< RWMOL_SPTR > RWMOL_SPTR_VECT
Definition: FileParsers.h:30
RDKit::RWMol::insertMol
void insertMol(const ROMol &other)
insert the atoms and bonds from other into this molecule
RDKit::RWMol
RWMol is a molecule class that is intended to be edited.
Definition: RWMol.h:30
RDKit::RWMol::addAtom
unsigned int addAtom(bool updateLabel=true)
adds an empty Atom to our collection
RDKit::ROMol::getNumAtoms
unsigned int getNumAtoms(bool onlyExplicit=1) const
returns our number of atoms
RDKit::RWMol::addBond
unsigned int addBond(BOND_SPTR bsp)
adds a Bond to our collection
Definition: RWMol.h:166
ROMol.h
Defines the primary molecule class ROMol as well as associated typedefs.
RDKit::ATOM_SPTR
boost::shared_ptr< Atom > ATOM_SPTR
Definition: Bond.h:26
RDKit::RWMol::replaceAtom
void replaceAtom(unsigned int idx, Atom *atom, bool updateLabel=false)
replaces a particular Atom
RDKit::Bond::BondType
BondType
the type of Bond
Definition: Bond.h:56
RDKit::ROMol
ROMol is a molecule class that is intended to have a fixed topology.
Definition: ROMol.h:102
RingInfo.h
RDKit::RWMol::RWMol
RWMol(const ROMol &other, bool quickCopy=false, int confId=-1)
copy constructor with a twist
Definition: RWMol.h:44
RDKit::RWMol::finishPartialBond
unsigned int finishPartialBond(unsigned int endAtomIdx, int bondBookmark, Bond::BondType order=Bond::UNSPECIFIED)
finishes a partially constructed bond
RDKit::RWMol::createPartialBond
Bond * createPartialBond(unsigned int beginAtomIdx, Bond::BondType order=Bond::UNSPECIFIED)
starts a Bond and sets its beginAtomIdx
RDKit
Includes a bunch of functionality for handling Atom and Bond queries.
Definition: Atom.h:28
RDKit::RWMOL_SPTR
boost::shared_ptr< RWMol > RWMOL_SPTR
Definition: RWMol.h:230
RDKit::RWMol::addAtom
unsigned int addAtom(ATOM_SPTR atom, bool updateLabel=true)
adds an Atom to our collection
Definition: RWMol.h:96
detail::computedPropName
const std::string computedPropName
Definition: types.h:25
RDKit::RWMol::removeBond
void removeBond(unsigned int beginAtomIdx, unsigned int endAtomIdx)
removes a bond from the molecule
RDKit::Bond
class for representing a bond
Definition: Bond.h:46
RDKit::RWMol::addBond
unsigned int addBond(Bond *bond, bool takeOwnership=false)
adds a Bond to our collection
Definition: RWMol.h:153
RDKit::RWMol::removeAtom
void removeAtom(unsigned int idx)
removes an Atom from the molecule
RDKit::RWMol::setActiveAtom
void setActiveAtom(Atom *atom)
sets our activeAtom
RDKit::Bond::UNSPECIFIED
Definition: Bond.h:57
RDKit::RWMol::RWMol
RWMol()
Definition: RWMol.h:32
RDKit::RWMol::operator=
RWMol & operator=(const RWMol &)
RDKit::ROMol::getAtomWithIdx
Atom * getAtomWithIdx(unsigned int idx)
returns a pointer to a particular Atom
RDKit::RWMol::getActiveAtom
Atom * getActiveAtom()
returns a pointer to the "active" Atom
RDKit::RWMol::addAtom
unsigned int addAtom(Atom *atom, bool updateLabel=true, bool takeOwnership=false)
adds an Atom to our collection
Definition: RWMol.h:77
RDKit::Atom
The class for representing atoms.
Definition: Atom.h:67
RDKit::RWMol::getLastAtom
Atom * getLastAtom()
returns a pointer to the highest-numbered Atom
Definition: RWMol.h:110
RDKit::STR_VECT
std::vector< std::string > STR_VECT
Definition: Dict.h:26
RDKit::RWMol::addBond
unsigned int addBond(unsigned int beginAtomIdx, unsigned int endAtomIdx, Bond::BondType order=Bond::UNSPECIFIED)
adds a Bond between the indicated Atoms